pdebuild-user-mode-linux 2.27 KB
Newer Older
dancer's avatar
+  
dancer committed
1 2
#! /bin/bash
#   pbuilder-user-mode-linux -- personal Debian package builder
3
#   Copyright (C) 2003-2007 Junichi Uekawa
dancer's avatar
+  
dancer committed
4 5 6 7 8 9 10 11 12 13 14 15 16
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
dancer's avatar
dancer committed
17 18
#   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA

dancer's avatar
+  
dancer committed
19 20 21 22 23 24 25
set -e

while ! test -d ./debian -o "$(pwd)" = "/" ; do
    cd ..;
done

if test ! -d ./debian; then
26
    echo "E: Cannot find ./debian dir" >&2 
dancer's avatar
+  
dancer committed
27 28 29
    exit 1
fi;
export PBCURRENTCOMMANDLINEOPERATION="pdebuild"
dancer's avatar
+  
dancer committed
30 31

. /usr/lib/pbuilder/pbuilder-loadconfig
32
. /usr/lib/pbuilder/pdebuild-uml-checkparams
dancer's avatar
+  
dancer committed
33 34 35 36 37

PKG_SOURCENAME=$(dpkg-parsechangelog|sed -n 's/^Source: //p')
PKG_VERSION=$(dpkg-parsechangelog|sed -n 's/^Version: \(.*:\|\)//p')
ARCHITECTURE=$(dpkg-architecture -qDEB_HOST_ARCH)

38

39
if [ "${USE_PDEBUILD_INTERNAL}" = 'yes' ]; then
dancer's avatar
dancer committed
40
    if [ ! readlink -f .. ]; then
41
	echo "E: Cannot find .. dir from PWD=$(pwd)" >&2 
dancer's avatar
+  
dancer committed
42 43
	exit 1
    fi
44
    pbuilder-user-mode-linux execute "$@" --bindmounts $(readlink -f ..) /usr/lib/pbuilder/pdebuild-internal ${PWD} --debbuildopts "" --debbuildopts "${DEBBUILDOPTS}"
45
else
dancer's avatar
dancer committed
46
    if ! dpkg-checkbuilddeps -B; then
47
	echo "W: Unmet build-dependency in source" >&2 
48
    fi
49 50 51
    CMD="dpkg-buildpackage -S -us -uc -r${BUILDSOURCEROOTCMD} $DEBBUILDOPTS"
    echo "I: Running $CMD" >&2
    echo "$CMD" | /bin/bash
dancer's avatar
dancer committed
52
    pbuilder-user-mode-linux build "$@" --buildresult "${UML_BUILDRESULT}" ../"${PKG_SOURCENAME}_${PKG_VERSION}".dsc
53 54
fi

55
# do signing with optional key specifier
dancer's avatar
+  
dancer committed
56
if [ "${AUTO_DEBSIGN}" = "yes" ]; then
57 58 59 60 61 62
    unset DEBSIGN_PARAM || true
    if [ -n "${DEBSIGN_KEYID}" ]; then
	DEBSIGN_PARAM[1]="-k${DEBSIGN_KEYID}"
    fi
    DEBSIGN_PARAM[2]="${UML_BUILDRESULT}/${PKG_SOURCENAME}_${PKG_VERSION}_${ARCHITECTURE}.changes"
    debsign "${DEBSIGN_PARAM[@]}"
dancer's avatar
+  
dancer committed
63
fi